package body Sorting is

    pragma Spark_Mode(On);
    pragma Assertion_Policy(Check);

    -- ---------------------------------------------------------------

    procedure Selection_Sort(A: in out Natural_Array) is
        Min_Index: Natural;
        Tmp: Natural;
    begin
        if Is_Empty(A) then
            return;
        end if;

        Outer:
        for I in A'range loop
            Min_Index := I;

            Inner:
            for J in I .. A'Last loop
                if A(J) < A(Min_Index) then 
                    Min_Index := J;
                end if;

                pragma Loop_Invariant(
                    (Min_Index in I .. J) 
                    and (for all K in I .. J => A(Min_Index) <= A(K))
                );

                pragma Loop_Invariant(
                    for all K in I .. J => A(K) = A'Loop_Entry(Inner)(K)
                );

                pragma Assert(
                    for all K in A'First .. I => A(K) = A'Loop_Entry(Inner)(K)
                );
            end loop Inner;

            pragma Assert(
                (Min_Index >= I) and then
                (for all K in I .. A'Last => A(Min_Index) <= A(K))
            );

            if A(Min_Index) < A(I) then
                Tmp  := A(I);
                A(I) := A(Min_Index);
                A(Min_Index) := Tmp;
            end if;

            pragma Loop_Invariant(
                (I in A'range) and then (Min_Index in I .. A'Last)
            );

            pragma Loop_Invariant(
                (for all K in I .. A'Last => A(I) <= A(K))
            );

            pragma Loop_Invariant(
                (I = Natural'First) or else
                (I > Natural'First and then
                    (for all K in A'First .. I-1 => A(K) <= A(K+1))
                )
            );
        end loop Outer;
    end Selection_Sort;

end Sorting;
