package Sorting is

    pragma Spark_Mode(On);
    
    pragma Assertion_Policy(Pre => Check);
    pragma Assertion_Policy(Post => Check);

    type Natural_Array is array(Natural range <>) of Natural;

    function Is_Empty(A: Natural_Array) return Boolean is
        (A'Length = 0);

    function Contains(A: Natural_Array; Item: Natural) return Boolean is
        (for some I in A'range => A(I) = Item);

    function Contains_All_Of(A: Natural_Array; B: Natural_Array) 
        return Boolean is
        (for all I in A'range => 
            (for some J in B'range => A(I) = B(J)));

    function Is_Sorted(A: Natural_Array) return Boolean is
        (Is_Empty(A)) or else
        (for all I in A'First .. A'Last-1 => A(I) <= A(I+1));

    procedure Selection_Sort(A: in out Natural_Array) with
        Pre  => (not Is_Empty(A)), 
        Post => Is_Sorted(A);

end Sorting;
